
# Contributing

When contributing to this repository, please first discuss the change you wish to make via issue,
email, or any other method with [Ernest Guevarra](mailto:ernest@validinternational.org) before making a change. 

Please note we have a [code of conduct](https://github.com/validmeasures/wash/blob/master/.github/CODE_OF_CONDUCT.md), please follow it in all your interactions with the project.

<br/>

## How to make a clean pull request

* Create a personal fork of this project on Github.

* Clone the fork on your local machine. Your remote repo on Github is called `origin`.

* Add the original repository as a remote called `upstream`.

* If you created your fork a while ago be sure to pull upstream changes into your local repository.

* Create a new branch to work on! Branch from `development`.

* Implement/fix your feature, comment your code.

* Follow the code style of the project, including indentation.

* Add or change the documentation as needed.

* Squash your commits into a single commit with git's [interactive rebase](https://help.github.com/articles/interactive-rebase). Create a new branch if necessary.

* Push your branch to your fork on Github, the remote `origin`.

* From your fork open a pull request in the correct branch using the specified [Pull Request Template](https://github.com/validmeasures/wash/blob/master/.github/PULL_REQUEST_TEMPLATE.md). Target this project's `development` branch. 

* Update the `README.md` with details of changes to the interface particularly changes in how indicators are defined or addition of new indicators.

* Increase the version numbers in any examples files and the `README.md` to the new version that this `Pull Request` would represent. The versioning scheme we use is [SemVer](http://semver.org/).

* You may then request [Ernest Guevarra](mailto:ernest@validinternational.org) to merge your `Pull Request` for you.

* Once the pull request is approved and merged you can pull the changes from `upstream` to your local repo and delete
your extra branch(es).

* And last but not least: Always write your commit messages in the present tense. Your commit message should describe what the commit, when applied, does to the code – not what you did to the code.

